package com.developpez.olegoaer.rpc;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Scanner;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.app.ProgressDialog;
import android.os.AsyncTask;
import android.util.Log;

import com.developpez.olegoaer.screen.LoremScreen;

public class DownloadLorem extends AsyncTask<Void, Void, ArrayList<String>> {

	private static final String BASE_URL = "http://loripsum.net/api/plaintext/short/20/";
	private LoremScreen screen;
	private HttpClient client;
	private ProgressDialog progress;
	
	public DownloadLorem(LoremScreen _owner) {
		this.screen = _owner;	
		this.client = new DefaultHttpClient();
		this.progress = new ProgressDialog(this.screen);
	}
	
	@Override
	protected void onPreExecute() {
		super.onPreExecute();		      		     
		progress.setTitle("Veuillez patientez");
		progress.setMessage("Rcupration des donnes en cours...");
		progress.setProgressStyle(ProgressDialog.STYLE_SPINNER);	  
	    progress.show();
	}
	
	@Override
	protected ArrayList<String> doInBackground(Void... params) {
	
		InputStream content = null;
		ArrayList<String> dummyTexts = new ArrayList<String>();
		
		try {
			HttpResponse response = this.client.execute(new HttpGet(BASE_URL));
			content = response.getEntity().getContent();
			
			Scanner scanner = new Scanner(new InputStreamReader(content));
			scanner.useDelimiter("\\s*\n");
			while (scanner.hasNext()) {
				dummyTexts.add(scanner.next().substring(0,30).concat("..."));		 
			}
			
		} catch (Exception e) { Log.e("RPC","Exception leve", e); }
		
		return dummyTexts;
	}

	@Override
	protected void onPostExecute(ArrayList<String> result) {
		
		super.onPostExecute(result);
		
		if(progress.isShowing())
			progress.dismiss();
		
		this.screen.populate(result);
	}
	
}
